/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSATSTypesetter;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSRect;
import dwt.internal.cocoa.NSTypesetter;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSATSTypesetter : NSTypesetter
{
    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSRect lineFragmentRectForProposedRect (NSRect proposedRect, objc.id remainingRect)
    {
        NSRect result;
        OS.objc_msgSend_stret(&result, this.id_, OS.sel_lineFragmentRectForProposedRect_1remainingRect_1, proposedRect, remainingRect);
        return result;
    }

    public static id sharedTypesetter ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSATSTypesetter, OS.sel_sharedTypesetter);
        return result !is null ? new id(result) : null;
    }
}
