/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSAnimationContext;

import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSAnimationContext : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public static void beginGrouping ()
    {
        OS.objc_msgSend(OS.class_NSAnimationContext, OS.sel_beginGrouping);
    }

    public static NSAnimationContext currentContext ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSAnimationContext, OS.sel_currentContext);
        return result !is null ? new NSAnimationContext(result) : null;
    }

    public double duration ()
    {
        return cast(double) OS.objc_msgSend_fpret(this.id_, OS.sel_duration);
    }

    public static void endGrouping ()
    {
        OS.objc_msgSend(OS.class_NSAnimationContext, OS.sel_endGrouping);
    }

    public void setDuration (double duration)
    {
        OS.objc_msgSend(this.id_, OS.sel_setDuration_1, duration);
    }

}
