/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSAssertionHandler;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSAssertionHandler : NSObject
{
    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public static NSAssertionHandler currentHandler ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSAssertionHandler, OS.sel_currentHandler);
        return result !is null ? new NSAssertionHandler(result) : null;
    }

    public void handleFailureInFunction (NSString functionName, NSString fileName, NSInteger line, NSString description)
    {
        OS.objc_msgSend(this.id_, OS.sel_handleFailureInFunction_1file_1lineNumber_1description_1, functionName !is null ? functionName.id_ : null,
                fileName !is null ? fileName.id_ : null, line, description !is null ? description.id_ : null);
    }

    public void handleFailureInMethod (objc.SEL selector, id object, NSString fileName, NSInteger line, NSString description)
    {
        OS.objc_msgSend(this.id_, OS.sel_handleFailureInMethod_1object_1file_1lineNumber_1description_1, selector, object !is null ? object.id_ : null,
                fileName !is null ? fileName.id_ : null, line, description !is null ? description.id_ : null);
    }
}
