/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSAutoreleasePool;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSAutoreleasePool : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public static void static_addObject_ (id anObject)
    {
        OS.objc_msgSend(OS.class_NSAutoreleasePool, OS.sel_addObject_1, anObject !is null ? anObject.id_ : null);
    }

    public void addObject_ (id anObject)
    {
        OS.objc_msgSend(this.id_, OS.sel_addObject_1, anObject !is null ? anObject.id_ : null);
    }

    public static NSUInteger autoreleasedObjectCount ()
    {
        return cast(NSUInteger) OS.objc_msgSend(OS.class_NSAutoreleasePool, OS.sel_autoreleasedObjectCount);
    }

    public void drain ()
    {
        OS.objc_msgSend(this.id_, OS.sel_drain);
    }

    public static void enableFreedObjectCheck (bool enable)
    {
        OS.objc_msgSend(OS.class_NSAutoreleasePool, OS.sel_enableFreedObjectCheck_1, enable);
    }

    public static void enableRelease (bool enable)
    {
        OS.objc_msgSend(OS.class_NSAutoreleasePool, OS.sel_enableRelease_1, enable);
    }

    public static NSUInteger poolCountHighWaterMark ()
    {
        return cast(NSUInteger) OS.objc_msgSend(OS.class_NSAutoreleasePool, OS.sel_poolCountHighWaterMark);
    }

    public static NSUInteger poolCountHighWaterResolution ()
    {
        return cast(NSUInteger) OS.objc_msgSend(OS.class_NSAutoreleasePool, OS.sel_poolCountHighWaterResolution);
    }

    public static void resetTotalAutoreleasedObjects ()
    {
        OS.objc_msgSend(OS.class_NSAutoreleasePool, OS.sel_resetTotalAutoreleasedObjects);
    }

    public static void setPoolCountHighWaterMark (NSUInteger count)
    {
        OS.objc_msgSend(OS.class_NSAutoreleasePool, OS.sel_setPoolCountHighWaterMark_1, count);
    }

    public static void setPoolCountHighWaterResolution (NSUInteger res)
    {
        OS.objc_msgSend(OS.class_NSAutoreleasePool, OS.sel_setPoolCountHighWaterResolution_1, res);
    }

    public static void showPools ()
    {
        OS.objc_msgSend(OS.class_NSAutoreleasePool, OS.sel_showPools);
    }

    public static NSUInteger topAutoreleasePoolCount ()
    {
        return cast(NSUInteger) OS.objc_msgSend(OS.class_NSAutoreleasePool, OS.sel_topAutoreleasePoolCount);
    }

    public static NSUInteger totalAutoreleasedObjects ()
    {
        return cast(NSUInteger) OS.objc_msgSend(OS.class_NSAutoreleasePool, OS.sel_totalAutoreleasedObjects);
    }

}
