/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSEPSImageRep;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSData;
import dwt.internal.cocoa.NSImageRep;
import dwt.internal.cocoa.NSRect;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSEPSImageRep : NSImageRep
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSData EPSRepresentation ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_EPSRepresentation);
        return result !is null ? new NSData(result) : null;
    }

    public NSRect boundingBox ()
    {
        NSRect result;
        OS.objc_msgSend_stret(&result, this.id_, OS.sel_boundingBox);
        return result;
    }

    public static id imageRepWithData (NSData epsData)
    {
        objc.id result = OS.objc_msgSend(OS.class_NSEPSImageRep, OS.sel_imageRepWithData_1, epsData !is null ? epsData.id_ : null);
        return result !is null ? new id(result) : null;
    }

    public id initWithData (NSData epsData)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithData_1, epsData !is null ? epsData.id_ : null);
        return result !is null ? new id(result) : null;
    }

    public void prepareGState ()
    {
        OS.objc_msgSend(this.id_, OS.sel_prepareGState);
    }

}
