/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSMutableCharacterSet;

import dwt.internal.cocoa.NSCharacterSet;
import dwt.internal.cocoa.NSRange;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSMutableCharacterSet : NSCharacterSet
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public void addCharactersInRange (NSRange aRange)
    {
        OS.objc_msgSend(this.id_, OS.sel_addCharactersInRange_1, aRange);
    }

    public void addCharactersInString (NSString aString)
    {
        OS.objc_msgSend(this.id_, OS.sel_addCharactersInString_1, aString !is null ? aString.id_ : null);
    }

    public void formIntersectionWithCharacterSet (NSCharacterSet otherSet)
    {
        OS.objc_msgSend(this.id_, OS.sel_formIntersectionWithCharacterSet_1, otherSet !is null ? otherSet.id_ : null);
    }

    public void formUnionWithCharacterSet (NSCharacterSet otherSet)
    {
        OS.objc_msgSend(this.id_, OS.sel_formUnionWithCharacterSet_1, otherSet !is null ? otherSet.id_ : null);
    }

    public void invert ()
    {
        OS.objc_msgSend(this.id_, OS.sel_invert);
    }

    public void removeCharactersInRange (NSRange aRange)
    {
        OS.objc_msgSend(this.id_, OS.sel_removeCharactersInRange_1, aRange);
    }

    public void removeCharactersInString (NSString aString)
    {
        OS.objc_msgSend(this.id_, OS.sel_removeCharactersInString_1, aString !is null ? aString.id_ : null);
    }

}
