/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSPipe;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSFileHandle;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSPipe : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSFileHandle fileHandleForReading ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_fileHandleForReading);
        return result !is null ? new NSFileHandle(result) : null;
    }

    public NSFileHandle fileHandleForWriting ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_fileHandleForWriting);
        return result !is null ? new NSFileHandle(result) : null;
    }

    public static id pipe ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSPipe, OS.sel_pipe);
        return result !is null ? new id(result) : null;
    }

}
