/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSProxy;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSInvocation;
import dwt.internal.cocoa.NSMethodSignature;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.NSZone;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSProxy : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    //public static id alloc() {
    //  objc.id result = OS.objc_msgSend(OS.class_NSProxy, OS.sel_alloc);
    //  return result !is null ? new id(result) : null;
    //}

    public static id allocWithZone (NSZone* zone)
    {
        objc.id result = OS.objc_msgSend(OS.class_NSProxy, OS.sel_allocWithZone_1, zone);
        return result !is null ? new id(result) : null;
    }

    //public static int class() {
    //  return OS.objc_msgSend(OS.class_NSProxy, OS.sel_class);
    //}

    public void dealloc ()
    {
        OS.objc_msgSend(this.id_, OS.sel_dealloc);
    }

    public NSString description ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_description);
        return result !is null ? new NSString(result) : null;
    }

    public void finalize ()
    {
        OS.objc_msgSend(this.id_, OS.sel_finalize);
    }

    public void forwardInvocation (NSInvocation invocation)
    {
        OS.objc_msgSend(this.id_, OS.sel_forwardInvocation_1, invocation !is null ? invocation.id_ : null);
    }

    public NSMethodSignature methodSignatureForSelector (objc.SEL sel)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_methodSignatureForSelector_1, sel);
        return result !is null ? new NSMethodSignature(result) : null;
    }

//public static bool respondsToSelector(int aSelector) {
//  return OS.objc_msgSend(OS.class_NSProxy, OS.sel_respondsToSelector_1, aSelector) !is null;
//}

}
