/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSTableHeaderCell;

import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSRect;
import dwt.internal.cocoa.NSTextFieldCell;
import dwt.internal.cocoa.NSView;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSTableHeaderCell : NSTextFieldCell
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public void drawSortIndicatorWithFrame (NSRect cellFrame, NSView controlView, bool ascending, NSInteger priority)
    {
        OS.objc_msgSend(this.id_, OS.sel_drawSortIndicatorWithFrame_1inView_1ascending_1priority_1, cellFrame,
                controlView !is null ? controlView.id_ : null, ascending, priority);
    }

    public NSRect sortIndicatorRectForBounds (NSRect theRect)
    {
        NSRect result;
        OS.objc_msgSend_stret(&result, this.id_, OS.sel_sortIndicatorRectForBounds_1, theRect);
        return result;
    }

}
