/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSTextList;

import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSTextList : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSTextList initWithMarkerFormat (NSString format, NSUInteger mask)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithMarkerFormat_1options_1, format !is null ? format.id_ : null, mask);
        return result !is null ? this : null;
    }

    public NSUInteger listOptions ()
    {
        return cast(NSUInteger) OS.objc_msgSend(this.id_, OS.sel_listOptions);
    }

    public NSString markerForItemNumber (NSInteger itemNum)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_markerForItemNumber_1, itemNum);
        return result !is null ? new NSString(result) : null;
    }

    public NSString markerFormat ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_markerFormat);
        return result !is null ? new NSString(result) : null;
    }

}
