/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSUniqueIDSpecifier;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSScriptClassDescription;
import dwt.internal.cocoa.NSScriptObjectSpecifier;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSUniqueIDSpecifier : NSScriptObjectSpecifier
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public id initWithContainerClassDescription (NSScriptClassDescription classDesc, NSScriptObjectSpecifier container, NSString property,
            id uniqueID)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithContainerClassDescription_1containerSpecifier_1key_1uniqueID_1,
                classDesc !is null ? classDesc.id_ : null, container !is null ? container.id_ : null, property !is null ? property.id_ : null,
                uniqueID !is null ? uniqueID.id_ : null);
        return result !is null ? new id(result) : null;
    }

    public void setUniqueID (id uniqueID)
    {
        OS.objc_msgSend(this.id_, OS.sel_setUniqueID_1, uniqueID !is null ? uniqueID.id_ : null);
    }

    public id uniqueID ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_uniqueID);
        return result !is null ? new id(result) : null;
    }

}
